POJ 3126 Prime Path(经典广搜BFS)

57 篇文章 0 订阅
22 篇文章 0 订阅

题目链接:http://poj.org/problem?id=3126

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 20231 Accepted: 11278
Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input

3
1033 8179
1373 8017
1033 1033
Sample Output

6
7
0

【中文题意】给你两个素数,问你第一个素数至少要经过多少次变换能变成第二个素数,如果不可能的话输出“Impossible”每一次变换应满足一下两个条件:
1.只能改变个十百千4个位数中的一个。
2.变成的新的数必须也得是素数
【思路分析】我们可以直接用筛法筛出1W以内的素数,然后用搜索的办法求出最小变换次数,具体看一下代码的注释。
【AC代码】

#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<queue>
using namespace std;

bool isprime[100005],book[10005];
void doprime()
{
    memset(isprime,1,sizeof(isprime));
    isprime[1]=0;
    for(int i=2;i<=10000;i++)
    {
        if(isprime[i])
        for(int j=2*i;j<=10000;j+=i)
        {
            isprime[j]=0;
        }
    }
}

struct node
{
    int x,step;
};

int bfs(int s,int t)
{
    memset(book,0,sizeof(book));
    book[s]=1;
    node fr,ne;
    fr.x=s;
    fr.step=0;
    queue<node>q;
    q.push(fr);
    while(!q.empty())
    {
        fr=q.front();
        q.pop();
        if(fr.x==t)
        {
            return fr.step;
        }
        int n4=fr.x%10,n3=(fr.x/10)%10,n2=(fr.x/100)%10,n1=(fr.x/1000)%10;
        for(int i=1;i<=9;i++)//千位
        {
            int y=i*1000+n2*100+n3*10+n4;
            if(book[y]==0&&isprime[y])
            {
                book[y]=1;
                ne.x=y;
                ne.step=fr.step+1;
                q.push(ne);
            }
        }
        for(int i=0;i<=9;i++)//百位
        {
            int y=n1*1000+i*100+n3*10+n4;
            if(book[y]==0&&isprime[y])
            {
                book[y]=1;
                ne.x=y;
                ne.step=fr.step+1;
                q.push(ne);
            }
        }
        for(int i=0;i<=9;i++)//十位
        {
            int y=n1*1000+n2*100+i*10+n4;
            if(book[y]==0&&isprime[y])
            {
                book[y]=1;
                ne.x=y;
                ne.step=fr.step+1;
                q.push(ne);
            }
        }
        for(int i=0;i<=9;i++)//个位
        {
            int y=n1*1000+n2*100+n3*10+i;
            if(book[y]==0&&isprime[y])
            {
                book[y]=1;
                ne.x=y;
                ne.step=fr.step+1;
                q.push(ne);
            }
        }
    }
    return -1;
}

int main()
{
    doprime();
    int t,m,n;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d%d",&n,&m);
        int re=bfs(n,m);
        int x=m;
        if(re==-1)
        {
            printf("Impossible\n");
        }
        else
        printf("%d\n",re);
    }
    return 0;
}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值